diff --git a/src/main/java/net/minecraft/core/world/Dimension.java b/src/main/java/net/minecraft/core/world/Dimension.java
index 6064be594..e3f8a6bda 100644
--- a/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/src/main/java/net/minecraft/core/world/Dimension.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.save.DimensionData;
 import net.minecraft.core.world.type.WorldType;
@@ -15,16 +15,17 @@ public class Dimension
 	public int id;
 	public final String languageKey;
 	public final Dimension homeDim;
-	public WorldType defaultWorldType;
+	public final WorldType defaultWorldType;
 	public final float worldScale;
 	public final int portalBlockId;
 	
-	public Dimension(String languageKey, Dimension homeDim, float worldScale, int portalBlockId)
+	public Dimension(String languageKey, Dimension homeDim, float worldScale, int portalBlockId, WorldType defaultWorldType)
 	{
 		this.languageKey = languageKey;
 		this.homeDim = homeDim;
 		this.worldScale = worldScale;
 		this.portalBlockId = portalBlockId;
+		this.defaultWorldType = defaultWorldType;
 	}
 	
 	public DimensionData getDimensionData(World world)
@@ -39,12 +40,6 @@ public class Dimension
 		return dimensionData;
 	}
 	
-	public Dimension setDefaultWorldType(WorldType defaultWorldType)
-	{
-		this.defaultWorldType = defaultWorldType;
-		return this;
-	}
-	
 	public boolean canPortal(Dimension dim)
 	{
 		if (homeDim == null) return true;
@@ -79,9 +74,9 @@ public class Dimension
 
 	private static final Map<Integer, Dimension> dimensionList = new HashMap<>();
 
-	public static final Dimension overworld;
-	public static final Dimension nether;
-	public static final Dimension paradise;
+	public static Dimension overworld;
+	public static Dimension nether;
+	public static Dimension paradise;
 
 	public static Map<Integer, Dimension> getDimensionList()
 	{
@@ -99,12 +94,10 @@ public class Dimension
 		dimension.id = id;
 		dimensionList.put(id, dimension);
 	}
-	
-	static
-	{
-		overworld = new Dimension("overworld", null, 1.0f, -1).setDefaultWorldType(WorldTypes.OVERWORLD_DEFAULT);
-		nether = new Dimension("hell", overworld, 0.125f, Block.portalNether.id).setDefaultWorldType(WorldTypes.NETHER_DEFAULT);
-		paradise = new Dimension("paradise", overworld, 8.0f, Block.portalParadise.id).setDefaultWorldType(WorldTypes.PARADISE_DEFAULT);
+	public static void init(){
+		overworld = new Dimension("overworld", null, 1.0f, -1, WorldTypes.OVERWORLD_DEFAULT);
+		nether = new Dimension("hell", overworld, 0.125f, Blocks.PORTAL_NETHER.id, WorldTypes.NETHER_DEFAULT);
+		paradise = new Dimension("paradise", overworld, 8.0f, Blocks.PORTAL_PARADISE.id, WorldTypes.PARADISE_DEFAULT);
 
 		registerDimension(0, overworld);
 		registerDimension(1, nether);
diff --git a/src/main/java/net/minecraft/core/world/Explosion.java b/src/main/java/net/minecraft/core/world/Explosion.java
index f79b4941e..af1baca0a 100644
--- a/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/src/main/java/net/minecraft/core/world/Explosion.java
@@ -1,16 +1,17 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkPosition;
-import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.util.helper.DamageType;
 
 import java.util.*;
@@ -40,11 +41,11 @@ public class Explosion {
 		explosionZ = z;
 		destroyBlocks = true;
 		if(!world.getGameRuleValue(GameRules.MOB_GRIEFING)) {
-		    destroyBlocks = entity == null || entity instanceof EntityPlayer;
+		    destroyBlocks = entity == null || entity instanceof Player;
 		}
 	}
 
-	public void doExplosionA() {
+	public void explode() {
 	    if(destroyBlocks) calculateBlocksToDestroy();
 	    
 		damageEntities();
@@ -52,12 +53,11 @@ public class Explosion {
 		if(destroyBlocks && isFlaming) createFire();
 	}
 
-    public void doExplosionB(boolean particles) {
+    public void addEffects(boolean particles) {
     	if(!worldObj.isClientSide) {
     		worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, explosionX, explosionY, explosionZ, "random.explode", 4F, (1.0F + (worldObj.rand.nextFloat() - worldObj.rand.nextFloat()) * 0.2F) * 0.7F);	
     	}
-        List<ChunkPosition> arraylist = new ArrayList<>();
-        arraylist.addAll(destroyedBlockPositions);
+        List<ChunkPosition> arraylist = new ArrayList<>(destroyedBlockPositions);
         for (int i = arraylist.size() - 1; i >= 0; i--) {
             ChunkPosition chunkposition = arraylist.get(i);
             
@@ -66,7 +66,7 @@ public class Explosion {
             int z = chunkposition.z;
             
             int id = worldObj.getBlockId(x, y, z);
-            TileEntity tileEntity = worldObj.getBlockTileEntity(x, y, z);
+            BlockEntity blockEntity = worldObj.getBlockEntity(x, y, z);
             if(particles) {
                 double xPos = (double) x + worldObj.rand.nextFloat();
                 double yPos = (double) y + worldObj.rand.nextFloat();
@@ -74,7 +74,7 @@ public class Explosion {
                 double d3 = xPos - explosionX;
                 double d4 = yPos - explosionY;
                 double d5 = zPos - explosionZ;
-                double d6 = MathHelper.sqrt_double(d3 * d3 + d4 * d4 + d5 * d5);
+                double d6 = MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
                 d3 /= d6;
                 d4 /= d6;
                 d5 /= d6;
@@ -88,7 +88,7 @@ public class Explosion {
             }
             if(id > 0)
             {
-                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity);
+                Block.blocksList[id].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[id].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
@@ -119,9 +119,9 @@ public class Explosion {
                         if(f1 <= 0.0F) {
                             continue label0;
                         }
-                        int j4 = MathHelper.floor_double(d5);
-                        int k4 = MathHelper.floor_double(d7);
-                        int l4 = MathHelper.floor_double(d9);
+                        int j4 = MathHelper.floor(d5);
+                        int k4 = MathHelper.floor(d7);
+                        int l4 = MathHelper.floor(d9);
                         int i5 = worldObj.getBlockId(j4, k4, l4);
                         if(i5 > 0) {
                             f1 -= (Block.blocksList[i5].getBlastResistance(exploder) + 0.3F) * f2;
@@ -142,26 +142,26 @@ public class Explosion {
 	protected void damageEntities() {
         float explosionSize2 = explosionSize * 2.0f;
         
-        int x1 = MathHelper.floor_double(explosionX - (double) explosionSize2 - 1.0D);
-        int x2 = MathHelper.floor_double(explosionX + (double) explosionSize2 + 1.0D);
-        int y1 = MathHelper.floor_double(explosionY - (double) explosionSize2 - 1.0D);
-        int y2 = MathHelper.floor_double(explosionY + (double) explosionSize2 + 1.0D);
-        int z1 = MathHelper.floor_double(explosionZ - (double) explosionSize2 - 1.0D);
-        int z2 = MathHelper.floor_double(explosionZ + (double) explosionSize2 + 1.0D);
+        int x1 = MathHelper.floor(explosionX - (double) explosionSize2 - 1.0D);
+        int x2 = MathHelper.floor(explosionX + (double) explosionSize2 + 1.0D);
+        int y1 = MathHelper.floor(explosionY - (double) explosionSize2 - 1.0D);
+        int y2 = MathHelper.floor(explosionY + (double) explosionSize2 + 1.0D);
+        int z1 = MathHelper.floor(explosionZ - (double) explosionSize2 - 1.0D);
+        int z2 = MathHelper.floor(explosionZ + (double) explosionSize2 + 1.0D);
         
-        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getBoundingBoxFromPool(x1, y1, z1, x2, y2, z2));
-        Vec3d vec3d = Vec3d.createVector(explosionX, explosionY, explosionZ);
+        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getTemporaryBB(x1, y1, z1, x2, y2, z2));
+        Vec3 vec3 = Vec3.getTempVec3(explosionX, explosionY, explosionZ);
         for (Entity entity : list) {
             double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double) explosionSize2;
             if (d4 <= 1.0D) {
                 double d6 = entity.x - explosionX;
                 double d8 = entity.y - explosionY;
                 double d10 = entity.z - explosionZ;
-                double d11 = MathHelper.sqrt_double(d6 * d6 + d8 * d8 + d10 * d10);
+                double d11 = MathHelper.sqrt(d6 * d6 + d8 * d8 + d10 * d10);
                 d6 /= d11;
                 d8 /= d11;
                 d10 /= d11;
-                double d12 = worldObj.func_675_a(vec3d, entity.bb);
+                double d12 = worldObj.getSeenPercent(vec3, entity.bb);
                 double d13 = (1.0D - d4) * d12;
                 entity.hurt(exploder, (int) (((d13 * d13 + d13) / 2D) * 8D * (double) explosionSize2 + 1.0D), DamageType.BLAST);
                 double d14 = d13;
@@ -183,7 +183,7 @@ public class Explosion {
 			int z1 = chunkposition.z;
 			
 			if(worldObj.getBlockId(x1, y1, z1) == 0 && Block.solid[worldObj.getBlockId(x1, y1 - 1, z1)] && ExplosionRNG.nextInt(3) == 0) {
-				worldObj.setBlockWithNotify(x1, y1, z1, Block.fire.id);
+				worldObj.setBlockWithNotify(x1, y1, z1, Blocks.FIRE.id);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index ff06bc095..3c4baa9fa 100644
--- a/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -1,15 +1,16 @@
 package net.minecraft.core.world;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.chunk.ChunkPosition;
-import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.util.helper.DamageType;
 
 import java.util.*;
@@ -22,7 +23,7 @@ public class ExplosionCannonball extends Explosion{
     }
 
     @Override
-	public void doExplosionA()
+	public void explode()
     {
         int i = 16;
         for(int j = 0; j < i; j++)
@@ -54,9 +55,9 @@ public class ExplosionCannonball extends Explosion{
                         {
                             continue label0;
                         }
-                        int j4 = MathHelper.floor_double(d5);
-                        int k4 = MathHelper.floor_double(d7);
-                        int l4 = MathHelper.floor_double(d9);
+                        int j4 = MathHelper.floor(d5);
+                        int k4 = MathHelper.floor(d7);
+                        int l4 = MathHelper.floor(d9);
                         int i5 = worldObj.getBlockId(j4, k4, l4);
                         if(i5 > 0)
                         {
@@ -78,15 +79,15 @@ public class ExplosionCannonball extends Explosion{
         }
 
         explosionSize *= 2.0F;
-        int k = MathHelper.floor_double(explosionX - (double)explosionSize - 1.0D);
-        int i1 = MathHelper.floor_double(explosionX + (double)explosionSize + 1.0D);
-        int k1 = MathHelper.floor_double(explosionY - (double)explosionSize - 1.0D);
-        int l1 = MathHelper.floor_double(explosionY + (double)explosionSize + 1.0D);
-        int i2 = MathHelper.floor_double(explosionZ - (double)explosionSize - 1.0D);
-        int j2 = MathHelper.floor_double(explosionZ + (double)explosionSize + 1.0D);
+        int k = MathHelper.floor(explosionX - (double)explosionSize - 1.0D);
+        int i1 = MathHelper.floor(explosionX + (double)explosionSize + 1.0D);
+        int k1 = MathHelper.floor(explosionY - (double)explosionSize - 1.0D);
+        int l1 = MathHelper.floor(explosionY + (double)explosionSize + 1.0D);
+        int i2 = MathHelper.floor(explosionZ - (double)explosionSize - 1.0D);
+        int j2 = MathHelper.floor(explosionZ + (double)explosionSize + 1.0D);
 //        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getBoundingBoxFromPool(k, k1, i2, i1, l1, j2));
-        List<Entity> list = worldObj.getEntitiesWithinAABB(Entity.class, AABB.getBoundingBoxFromPool(k, k1, i2, i1, l1, j2)); // Cannon balls can explode their owners
-        Vec3d vec3d = Vec3d.createVector(explosionX, explosionY, explosionZ);
+        List<Entity> list = worldObj.getEntitiesWithinAABB(Entity.class, AABB.getTemporaryBB(k, k1, i2, i1, l1, j2)); // Cannon balls can explode their owners
+        Vec3 vec3 = Vec3.getTempVec3(explosionX, explosionY, explosionZ);
         for(int k2 = 0; k2 < list.size(); k2++)
         {
             Entity entity = list.get(k2);
@@ -96,11 +97,11 @@ public class ExplosionCannonball extends Explosion{
                 double d6 = entity.x - explosionX;
                 double d8 = entity.y - explosionY;
                 double d10 = entity.z - explosionZ;
-                double d11 = MathHelper.sqrt_double(d6 * d6 + d8 * d8 + d10 * d10);
+                double d11 = MathHelper.sqrt(d6 * d6 + d8 * d8 + d10 * d10);
                 d6 *= 2.5;
                 d8 /= d11;
                 d10 *= 2.5;
-                double d12 = worldObj.func_675_a(vec3d, entity.bb);
+                double d12 = worldObj.getSeenPercent(vec3, entity.bb);
                 double d13 = (1.0D - d4) * d12;
                 entity.hurt(exploder, (int)(((d13 * d13 + d13) / 2D) * 8D * (double)explosionSize + 1.0D), DamageType.BLAST);
                 entity.xd += d6 * d13;
@@ -122,7 +123,7 @@ public class ExplosionCannonball extends Explosion{
                 int i4 = worldObj.getBlockId(i3, j3 - 1, k3);
                 if(l3 == 0 && Block.solid[i4] && ExplosionRNG.nextInt(3) == 0)
                 {
-                    worldObj.setBlockWithNotify(i3, j3, k3, Block.fire.id);
+                    worldObj.setBlockWithNotify(i3, j3, k3, Blocks.FIRE.id);
                 }
             }
 
@@ -130,7 +131,7 @@ public class ExplosionCannonball extends Explosion{
     }
 
     @Override
-	public void doExplosionB(boolean flag)
+	public void addEffects(boolean flag)
     {
     	if(!worldObj.isClientSide) {
     		worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, explosionX, explosionY, explosionZ, "random.explode", 4F, (1.0F + (worldObj.rand.nextFloat() - worldObj.rand.nextFloat()) * 0.2F) * 0.7F);	
@@ -143,7 +144,7 @@ public class ExplosionCannonball extends Explosion{
             int y = chunkposition.y;
             int z = chunkposition.z;
             int i1 = worldObj.getBlockId(x, y, z);
-            TileEntity tileEntity = worldObj.getBlockTileEntity(x, y, z);
+            BlockEntity blockEntity = worldObj.getBlockEntity(x, y, z);
             if(flag)
             {
                 double d = (double)x + worldObj.rand.nextFloat();
@@ -152,7 +153,7 @@ public class ExplosionCannonball extends Explosion{
                 double d3 = d - explosionX;
                 double d4 = d1 - explosionY;
                 double d5 = d2 - explosionZ;
-                double d6 = MathHelper.sqrt_double(d3 * d3 + d4 * d4 + d5 * d5);
+                double d6 = MathHelper.sqrt(d3 * d3 + d4 * d4 + d5 * d5);
                 d3 /= d6;
                 d4 /= d6;
                 d5 /= d6;
@@ -164,14 +165,14 @@ public class ExplosionCannonball extends Explosion{
                 worldObj.spawnParticle("explode", (d + explosionX) / 2D, (d1 + explosionY) / 2D, (d2 + explosionZ) / 2D, d3, d4, d5, 0 );
                 worldObj.spawnParticle("smoke", d, d1, d2, d3, d4, d5, 0);
             }
-            if(i1 > 0 && (Block.blocksList[i1].id == Block.glass.id
+            if(i1 > 0 && (Block.blocksList[i1].id == Blocks.GLASS.id
                     ||  Block.blocksList[i1].blockMaterial == Material.topSnow
                     ||  Block.blocksList[i1].blockMaterial == Material.plant
                     ||  Block.blocksList[i1].blockMaterial == Material.web
                     ||  Block.blocksList[i1].blockMaterial == Material.decoration
                     ||  Block.blocksList[i1].blockMaterial == Material.ice))
             {
-                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), tileEntity);
+                Block.blocksList[i1].dropBlockWithCause(worldObj, EnumDropCause.EXPLOSION, x, y, z, worldObj.getBlockMetadata(x, y, z), blockEntity);
                 worldObj.setBlockWithNotify(x, y, z, 0);
                 Block.blocksList[i1].onBlockDestroyedByExplosion(worldObj, x, y, z);
             }
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 03d381c3f..2df368461 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.world;
 
 // Referenced classes of package net.minecraft.src:
-//            Entity, TileEntity, EntityPlayer
+//            Entity, BlockEntity, Player
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.sound.SoundCategory;
 
 public interface LevelListener
@@ -50,7 +50,7 @@ public interface LevelListener
 
     void playStreamingMusic(String soundPath, String Author, int x, int y, int z);
 
-    void tileEntityChanged(int x, int y, int z, TileEntity tileEntity);
+    void tileEntityChanged(int x, int y, int z, BlockEntity blockEntity);
 
-    void levelEvent(EntityPlayer player, int id, int x, int y, int z, int data);
+    void levelEvent(Player player, int id, int x, int y, int z, int data);
 }
diff --git a/src/main/java/net/minecraft/core/world/PortalHandler.java b/src/main/java/net/minecraft/core/world/PortalHandler.java
index b1c487cb8..951f79909 100644
--- a/src/main/java/net/minecraft/core/world/PortalHandler.java
+++ b/src/main/java/net/minecraft/core/world/PortalHandler.java
@@ -3,14 +3,14 @@ package net.minecraft.core.world;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockPortal;
+import net.minecraft.core.block.PortalBlock;
 import net.minecraft.core.world.type.WorldType;
 
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            Entity, MathHelper, World, Block, 
-//            BlockPortal, Material
+//            PortalBlock, Material
 
 public class PortalHandler
 {
@@ -36,8 +36,8 @@ public class PortalHandler
         int closestPortalX = 0;
         int closestPortalY = 0;
         int closestPortalZ = 0;
-        int entityBlockX = MathHelper.floor_double(entity.x);
-        int entityBlockZ = MathHelper.floor_double(entity.z);
+        int entityBlockX = MathHelper.floor(entity.x);
+        int entityBlockZ = MathHelper.floor(entity.z);
         
         WorldType oldWorldType = oldDim.getDimensionData(world).getWorldType();
         WorldType newWorldType = newDim.getDimensionData(world).getWorldType();
@@ -140,9 +140,9 @@ public class PortalHandler
 
         byte portalSearchRadius = 16;
         double lowestEntityDistance = -1D;
-        int blockX = MathHelper.floor_double(entity.x);
-        int blockY = MathHelper.floor_double(entityPosYScaled);
-        int blockZ = MathHelper.floor_double(entity.z);
+        int blockX = MathHelper.floor(entity.x);
+        int blockY = MathHelper.floor(entityPosYScaled);
+        int blockZ = MathHelper.floor(entity.z);
         int closestPortalX = blockX;
         int closestPortalY = blockY;
         int closestPortalZ = blockZ;
@@ -153,12 +153,12 @@ public class PortalHandler
         
         if (newDim.homeDim == null)
         {
-        	targetPortalFrameId = ((BlockPortal) Block.blocksList[oldDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((PortalBlock) Block.blocksList[oldDim.portalBlockId]).portalFrameId;
         	targetPortalId = oldDim.portalBlockId;
         }
         else
         {
-        	targetPortalFrameId = ((BlockPortal)Block.blocksList[newDim.portalBlockId]).portalFrameId;
+        	targetPortalFrameId = ((PortalBlock)Block.blocksList[newDim.portalBlockId]).portalFrameId;
         	targetPortalId = newDim.portalBlockId;
         }
         
@@ -324,7 +324,7 @@ label1:
 
             }
             
-            ((BlockPortal)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ);
+            ((PortalBlock)Block.blocksList[targetPortalId]).tryToCreatePortal(world, portalX,  portalY,  portalZ);
 
             world.editingBlocks = false;
             for(int k6 = 0; k6 < 4; k6++)
